#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_ArenaTaskCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_ArenaTaskCFG> Fish_ArenaTaskCFG::msSingleton(nullptr);

int Fish_ArenaTaskCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ArenaTaskCFGData* Fish_ArenaTaskCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_ArenaTaskCFGData>& Fish_ArenaTaskCFG::GetMapData()
{
	return mMapData;
}

void Fish_ArenaTaskCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_ArenaTaskCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ArenaTaskCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mGroup = element->IntAttribute("Group");
		data.mTaskDesc = element->Attribute("TaskDesc");
		data.mfishId = element->IntAttribute("fishId");
		data.mneedCount = element->IntAttribute("needCount");
		data.mType = element->IntAttribute("Type");
		data.mTaskReward = element->IntAttribute("TaskReward");
		data.mTaskRewardDesc1 = element->Attribute("TaskRewardDesc1");
		data.mTaskRewardDesc2 = element->Attribute("TaskRewardDesc2");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_ArenaTaskCFG::Load()
{
	Load("../Config/Fish_ArenaTaskCFG.xml");
}

Fish_ArenaTaskCFG* Fish_ArenaTaskCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ArenaTaskCFG());
	}
	return msSingleton.get();
}
